#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MIN_N = 1;
const int MAX_N = 1000;
const int MIN_T = 1;
const int MAX_T = 10000;
const int MIN_NI = 1;
const int MAX_NI = 1000;

const int rnd_test_n = 100;

template <typename T> void append(vector<T> &dest, const vector<T> &orig) {
	dest.insert(dest.end(), orig.begin(), orig.end());
}

vector<int> genRandomArray(int size = 0, int minv = MIN_NI, int maxv = MAX_NI) {
    if (size <= 0) size = rnd.next(MIN_N, MAX_N);
    vector<int> arr(size);
    for (int i = 0; i < size; i++) {
        arr[i] = rnd.next(minv, maxv);
    }
    return arr;
}

string output_tc(int t, const vector<int>& nums) {
	ostringstream oss;
    oss << nums.size() << " " << t << endl;
    for (int i = 0; i < nums.size(); i++) {
        if (i != 0) oss << " ";
        oss << nums[i];
    }
    oss << endl;
	return oss.str();
}

vector<string> generate_sample_tests() {
	vector<string> tests;
    tests.push_back(output_tc(10, {1, 2, 3, 4, 5}));
    tests.push_back(output_tc(4, {5, 1, 2, 5}));
    tests.push_back(output_tc(14, {1, 2, 3, 4, 4, 9, 9, 15}));
	return tests;
}

vector<string> generate_manual_tests() {
	vector<string> tests;
	tests.push_back(output_tc(1, {2,2,2,2,2,2,2,2}));
	tests.push_back(output_tc(2, {100, 100, 100, 3, 3, 3, 3, 3, 3, 2}));
	return tests;
}

string rnd_test(int i){
    int min_n = MIN_N;
    int max_n = MAX_N;
    int min_t = MIN_T;
    
    if(i<rnd_test_n / 3){
        max_n = MAX_N/3;
        min_t = 10;
    }
    else if(i<rnd_test_n / 2){
        max_n = MAX_N/2;
        min_t = 100;
    } else {
        min_t = 1000;
    }

    int n = rnd.next(min_n, max_n);
    int t = rnd.next(min_t, MAX_T);
    return(output_tc(t, genRandomArray(n, t/10)));
}

vector<string> generate_random_tests() { 
    vector<string> tests;
    for (int i = 0; i < rnd_test_n; i++){
        tests.push_back(rnd_test(i));
    } 
    return tests;
}

string extreme_test_1(){
    return(output_tc(MAX_N, genRandomArray(MAX_N, MAX_N/2, MAX_N-1)));
}

string extreme_test_2(){
    return(output_tc(MAX_T - 1, genRandomArray(MAX_N, MAX_NI)));
}

vector<string> generate_extreme_tests(){
    vector<string> tests;   
    tests.push_back(extreme_test_1());
    tests.push_back(extreme_test_2());
    return tests;
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);
	vector<string> tests;
	size_t test = 0;
	append(tests, generate_sample_tests());
	append(tests, generate_manual_tests());
	append(tests, generate_random_tests());
	append(tests, generate_extreme_tests());
	for (const auto &t : tests) {
		startTest(++test);
		cout << t;
	}
	return 0;
}